import java.util.Scanner;

public class Piratas {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int numTestes = sc.nextInt();
		int linhas, colunas, x, y;
		char[][] mapa;
		while (numTestes > 0) {
			numTestes--;
			linhas = sc.nextInt();
			colunas = sc.nextInt();
			x = sc.nextInt();
			y = sc.nextInt();
			mapa = new char[linhas][colunas];
			for (int i = 0; i < linhas; i++) {
				String linhaMapa = sc.next();
				for (int j = 0; j < colunas; j++)
					mapa[i][j] = linhaMapa.charAt(j);
			}
			
			if (buscaTerra(mapa, x-1, y-1))
				System.out.println("TESOURO A VISTA, CAPITAO!");
			else
				System.out.println("O MAR ESTA PERIGOSO, CAPITAO!");
		}
	}
	
	public static boolean buscaTerra(char[][] mapa, int x, int y) {
		//condicoes de parada da busca:
			//coordenadas fora do mapa
			//lugar que nao eh seguro
			//lugar que ja foi visitado (que estamos marcando com o caracter V)
		if (!estaNoMapa(mapa, x, y) || mapa[x][y] == '*' || mapa[x][y] == 'V')
			return false;
		
		//Caso nao seja agua comeca a busca por tesouro
		if (mapa[x][y] != '=')
			return buscaTesouro(mapa, x, y);
		
		//Marca como visitado
		mapa[x][y] = 'V';
		
		//visita os visinhos
		if (buscaTerra(mapa, x+1, y))
			return true;
		if (buscaTerra(mapa, x-1, y))
			return true;
		if (buscaTerra(mapa, x, y+1))
			return true;
		return buscaTerra(mapa, x, y-1);
	}
	
	public static boolean buscaTesouro(char[][] mapa, int x, int y) {
		//Condicoes de parada:
			//Coordenadas fora do mapa
			//Lugar que ja foi visitado (marcado com V)
			//Nao eh um lugar com terra nem tesouro
		if (!estaNoMapa(mapa, x, y) || mapa[x][y] == 'V' || (mapa[x][y] != 'T' && mapa[x][y] != 'X'))
			return false;
		
		// Verifica se achou o tesouro
		if (mapa[x][y] == 'X')
			return true;
		
		// Marca como visitado
		mapa[x][y] = 'V';
		
		// Visita vizinhos
		if (buscaTesouro(mapa, x+1, y))
			return true;
		if (buscaTesouro(mapa, x-1, y))
			return true;
		if (buscaTesouro(mapa, x, y+1))
			return true;
		return buscaTesouro(mapa, x, y-1);
	}

	// Retorna true caso as coordenadas passadas estao no mapa e false caso contrario
	public static boolean estaNoMapa(char[][] mapa, int x, int y) {
		return (x >= 0 && x < mapa.length && y >= 0 && y < mapa[0].length);
	}
}